---
title: WindowEventHandlers.onhashchange
slug: Web/API/WindowEventHandlers/onhashchange
tags:
  - Event Handler
  - HTML-DOM
  - Hash
  - Property
  - Reference
  - URL & Hash
  - WindowEventHandlers
---
<div>{{APIRef("HTML DOM")}}</div>

<p>The <code><strong>WindowEventHandlers.onhashchange</strong></code> property of the {{domxref("WindowEventHandlers")}} mixin is the {{domxref("EventHandler")}} for processing <code><a href="/en-US/docs/Web/API/Window/hashchange_event">hashchange</a></code> events.</p>

<p>The <code>hashchange</code> event fires when a window's hash changes (see {{domxref("Window.location")}} and {{domxref("HTMLHyperlinkElementUtils.hash")}}).</p>

<h2 id="Syntax">Syntax</h2>

<p><strong>Using an event handler:</strong></p>

<pre class="syntaxbox">window.onhashchange = funcRef;
</pre>

<p><strong>Using an HTML event handler:</strong></p>

<pre class="syntaxbox">&lt;body onhashchange="funcRef();"&gt;
</pre>

<p><strong>Using an event listener:</strong></p>

<p>To add an event listener, use {{domxref("EventTarget.addEventListener()", "addEventListener()")}}:</p>

<pre class="syntaxbox">window.addEventListener("hashchange", funcRef, false);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>funcRef</code></dt>
 <dd>A reference to a function.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<h3 id="Using_an_event_handler">Using an event handler</h3>

<p>This example uses an event handler (<code>window.onhashchange</code>) to check the new hash value whenever it changes. If it equals <code>#cool-feature</code>, the script logs a message to the console.</p>

<pre class="brush:js">function locationHashChanged() {
  if (location.hash === '#cool-feature') {
    console.log("You're visiting a cool feature!");
  }
}

window.onhashchange = locationHashChanged;
</pre>

<h3 id="Using_an_event_listener">Using an event listener</h3>

<p>This example uses an event listener to log a notification whenever the hash has changed.</p>

<pre class="brush:js">function hashHandler() {
  console.log('The hash has changed!');
}

window.addEventListener('hashchange', hashHandler, false);
</pre>

<h3 id="Overriding_the_hash">Overriding the hash</h3>

<p>This function sets a new hash dynamically, setting it randomly to one of two values.</p>

<pre class="brush:js">function changeHash() {
  location.hash = (Math.random() &gt; 0.5) ? 'location1' : 'location2';
}
</pre>

<h2 id="The_hashchange_event">The hashchange event</h2>

<p>The dispatched <code>hashchange</code> event has the following properties:</p>

<table class="standard-table">
 <tbody>
  <tr>
   <td class="header">Field</td>
   <td class="header">Type</td>
   <td class="header">Description</td>
  </tr>
  <tr>
   <td><code>newURL</code></td>
   <td><code>DOMString</code></td>
   <td>The new URL to which the window is navigating.</td>
  </tr>
  <tr>
   <td><code>oldURL</code></td>
   <td><code>DOMString</code></td>
   <td>The previous URL from which the window was navigated.</td>
  </tr>
 </tbody>
</table>

<h3 id="Polyfill_for_event.newURL_and_event.oldURL">Polyfill for event.newURL and event.oldURL</h3>

<pre class="brush:js">// Let this snippet run before your hashchange event binding code
if (!window.HashChangeEvent)(function(){
  var lastURL = document.URL;
  window.addEventListener("hashchange", function(event){
    Object.defineProperty(event, "oldURL", {enumerable:true,configurable:true,value:lastURL});
    Object.defineProperty(event, "newURL", {enumerable:true,configurable:true,value:document.URL});
    lastURL = document.URL;
  });
}());
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('HTML WHATWG', '#handler-window-onhashchange', 'onhashchange')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName('HTML5.1', '#windoweventhandlers', 'GlobalEventHandlers')}}</td>
   <td>{{Spec2('HTML5.1')}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5 W3C", "#windoweventhandlers", "GlobalEventHandlers")}}</td>
   <td>{{Spec2('HTML5 W3C')}}</td>
   <td> </td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.WindowEventHandlers.onhashchange")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/API/Window/hashchange_event">hashchange</a></code> event</li>
 <li><a href="/en-US/docs/DOM/Manipulating_the_browser_history" title="DOM/Manipulating the browser history">Manipulating the browser history</a></li>
 <li><a href="/en-US/docs/DOM/window.history" title="DOM/window.history"><code>history.pushState()</code> and <code>history.replaceState()</code></a> methods</li>
 <li>{{domxref("WindowEventHandlers.onpopstate")}}</li>
 <li>{{domxref("HTMLHyperlinkElementUtils.hash")}}</li>
</ul>
